# Tutorial

:project Tutorial: First project

## Project Window

:position 30,30,40,40

:overlay

### Project Window

The project window opens when you create a new project or open one of your existing
projects. This is where you program, test, create sprites,
maps and set all the details of your project.

## Navigation

### Navigate in project

A column of icons is located on the left-hand side of the screen. It allows to
quickly open the code editor, sprite editor, maps, documentation, settings and publishing
options of your project.

:highlight #projectview .sidemenu ul


## Code Section

### Coding and executing

Click on **Code** to open the first section.

:highlight #projectview .sidemenu #menuitem-code

:auto


## Code Section 2

:navigate projects.code

### Coding and executing

In this section you can create your program, execute your application, test and debug.
The left-hand side of the screen is the code editor, where you will write your program.
The right-hand side of the screen includes an execution view at the top and a console
at the bottom, where you can write commands, check variables or modify them in realtime
while your program is running.

## Sprites Section

### Sprites

Click **Sprites** to open the sprite editor.

:highlight #projectview .sidemenu #menuitem-sprites

:auto

## Sprites Section 2

:navigate projects.sprites

### Sprites

This is the sprite editor. *Sprites* are images that you can design here and then
refer to from your code to draw them on screen. Click on a sprite in the left-hand
list to open it, then use the drawing functions on the right-hand side and start drawing.

## Section Maps

### Maps

Click **Maps** to open the map editor.

:highlight #projectview .sidemenu #menuitem-maps

:auto

## Section Maps 2

:navigate projects.maps

### Maps

This is the map editor. Maps are often used to create levels for video games, or to
create environments that can be explored. They are created by putting sprites together
on a grid. Sprites are chosen among those you designed in the Sprites section.

Click "Add Map" to create your first map and start drawing on the grid.

## Section Doc

### Doc

Click **Doc** to open the doc editor.

:highlight #projectview .sidemenu #menuitem-doc

:auto

## Section Doc 2

:navigate projects.doc

### Doc

Here is the doc (documentation) editor. Whenever your project is a plug-in which
is intended to be used by others, or a demo for which you want to add explanations,
you can write a documentation here using the markdown language. microStudio tutorials
themselves are created with this editor!

## Settings Section

### Settings

Click **Settings** to open the project settings.

:highlight #projectview .sidemenu #menuitem-options

:auto

## Settings Section 2

:navigate projects.options

### Settings

In this section you can edit the title and the URL of your project. You can also
change the secret word used to keep your project private while allowing you to test it on
different devices. You can set the suitable screen orientation for your project. Finally,
you can invite your friends to contribute to your project. All you need to send invites is their
microStudio nickname.

## Publish Section

### Publish

Click **Publish** to open the publishing options panel.

:highlight #projectview .sidemenu #menuitem-publish

:auto

## Publish Section 2

:navigate projects.publish

### Publier

When your project is complete, you can make it publicly available to all microStudio
users. You can also keep it private and export it to HTML5, which allows you to publish
it on your own website or on a game publishing platform.


## End

This tutorial is over. You can now launch tutorial "First Project" to start creating
your first application with microStudio.
